#include <pthread.h>
#include <stdio.h> 
#include <stdlib.h> 
#define NUM_THREADS 2

/*
 * Esempio relativo alle corse critiche. 
 * I due thread lavorano sulle variabili condivise
 * balance e numOperations senza mutua esclusione.
 * Questo porta a inconsistenze (il valore di balance
 * dovrebbe essere sempre uguale al valore di numOperations
 * moltiplicato per 10).
 */

int numOperations;
int balance;

void deposit(int tid){
  numOperations++;  
  balance += 10;
  if(numOperations*10 != balance) {
    printf("Thread %d EXIT: balance=%d, num.op.=%d\n", tid, balance, numOperations);
    exit(1);
  }
}
 
void* my_thread(void* threadid) { 
  int tid; 
  tid = *((int*) threadid); 
  while(1) { 
    deposit(tid);
  }
} 

int main(int argc, char *argv[]) { 
  pthread_t threads[NUM_THREADS]; 
  int ids[NUM_THREADS];
  int rc; 
  int t; 
  for(t=0; t<NUM_THREADS; t++) { 
    ids[t] = t;
    rc = pthread_create(&threads[t], NULL, my_thread, &ids[t]); 
    if (rc) { 
       printf("ERROR; return code from pthread_create() is %d\n", rc); 
       exit(-1);
    } 
  } 
  pthread_exit(NULL);
}

